!(function () {

    var originData = {
        label: [
            // "a7ed634a-0b59-4392-b92d-93a408803287"
        ],
        labels: [
            {
                dimension: {
                    id: "4ac8a4f8-5798-4c18-9cdf-9b1b9e7f9372",
                    name: "部门",
                    status: 1,
                    description: null,
                    createTime: "2022-03-29 15:44:36.114"
                },
                labels: [
                    {
                        id: "85253c00-268c-4c77-a87d-6c532853ff1d",
                        name: "研发",
                        description: null,
                        dimensionId: "4ac8a4f8-5798-4c18-9cdf-9b1b9e7f9372",
                        createTime: "2022-03-29 15:45:18.348"
                    },
                    {
                        id: "f18d4479-9220-43f5-a696-b408b59c75c0",
                        name: "行政",
                        description: null,
                        dimensionId: "4ac8a4f8-5798-4c18-9cdf-9b1b9e7f9372",
                        createTime: "2022-03-29 15:45:07.412"
                    },
                    {
                        id: "a7ed634a-0b59-4392-b92d-93a408803287",
                        name: "财务",
                        description: null,
                        dimensionId: "4ac8a4f8-5798-4c18-9cdf-9b1b9e7f9372",
                        createTime: "2022-03-29 15:45:12.398"
                    }
                ]
            }
        ]
    };


    var TestTreeSingleChooserModel = BI.inherit(Fix.Model, {

        state: function () {
            // 所有标签
            var rawDimension = [], defaultDimension = {};
            BI.each(originData.labels, function (i, item) {
                var temp = {
                    text: item.dimension.name,
                    value: item.dimension.id,
                    children: BI.isNotEmptyArray(item.labels) ? BI.sortBy(BI.map(item.labels, function (i, label) {
                        return {
                            text: label.name,
                            value: label.id
                        };
                    }), [function (item) {
                        return BI.makeFirstPY(item["name"]);
                    }]) : []
                };
                rawDimension.push(temp);
            });
            rawDimension = BI.sortBy(rawDimension, [function (item) {
                return BI.makeFirstPY(item["text"]);
            }]);
            !BI.isEmpty(defaultDimension) && rawDimension.unshift(defaultDimension);
           
            console.log("state --> labels", rawDimension);
            console.log("state --> label", originData.label);

            return {
                labels: rawDimension,
                label: originData.label
                
            };
        }
    });
    BI.model("dec.amiba.test.tree.single.chooser.model", TestTreeSingleChooserModel);


    var TestTreeSingleChooser = BI.inherit(BI.Widget, {
        _store: function () {
            return BI.Models.getModel("dec.amiba.test.tree.single.chooser.model");
        },
       
        watch: {
            labels: function (v) {
                console.log("labels", v);
            },
            label: function (v) {
                console.log("label", v);
            }
        },
        mounted: function () {
            var _this = this;
            setTimeout(function () {
                console.log("_this.dataLabelRef", _this.dataLabelRef);
                _this.dataLabelRef.setValue(["a7ed634a-0b59-4392-b92d-93a408803287"]);
            }, 3000);
        },
        render: function () {
            var _this = this, o = this.options, m = this.model;
            console.log("_this.label", _this);
            return {
                type: "bi.vertical",
                height: 150,
                lgap: 20,
                tgap: 20,
                mounted: function () {},
                items: [
                    {
                        type: "bi.label",
                        textAlign: "left",
                        text: "层级单选下拉框"
                    },
                    {
                        type: "dec.amiba.components.tree.single.chooser.combo",
                        watermark: "请选择",
                        text: "无效值",
                        width: 300,
                        height: 32,
                        value: m.label,
                        items: m.labels,
                        ref: function (ref) {
                            _this.dataLabelRef = ref;
                        },
                        listeners: [{
                            eventName: "EVENT_CHANGE",
                            action: function (value) {
                                m.label = value;
                            }
                        }]
                    }
                ]
            };
        }
    });

    BI.shortcut("dec.amiba.test.tree.single.chooser", TestTreeSingleChooser);

})();